package cn.cecep.talroad.controller.analysis;

import cn.cecep.talroad.common.core.exception.CommonException;
import cn.cecep.talroad.common.core.utils.poi.ExcelUtil;
import cn.cecep.talroad.common.core.web.controller.BasesController;
import cn.cecep.talroad.common.core.web.domain.AjaxResults;
import cn.cecep.talroad.common.log.annotation.Log;
import cn.cecep.talroad.common.log.enums.BusinessType;
import cn.cecep.talroad.common.security.annotation.RequiresPermissions;
import cn.cecep.talroad.domain.analysis.PcRaProblemType;
import cn.cecep.talroad.service.analysis.IPcRaProblemTypeService;
import cn.cecep.talroad.vo.analysis.PcRaProblemTypeVo;
import cn.cecep.talroad.vo.query.analysis.PcRaProblemTypeQuery;
import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.security.InvalidParameterException;
import java.util.Arrays;
import java.util.List;
import java.util.Map;


/**
 * * 开发公司：中节能天融科技有限公司
 * 问题分类Controller 控制层
 *
 * @author szhpt
 * @date 2023-03-24
 */
@Api(tags = "问题分类")
@RestController
@RequestMapping("/problemType")
public class PcRaProblemTypeController extends BasesController {
    @Autowired
    private IPcRaProblemTypeService pcRaProblemTypeService;

    /**
     * 查询问题分类列表
     */
    @ApiOperation(value = "查询问题分类")
    @GetMapping("/list")
    public AjaxResults<IPage<PcRaProblemType>> list(PcRaProblemTypeQuery pcRaProblemType) {
        Page<PcRaProblemType> page = new Page<>(pcRaProblemType.getPageNum(), pcRaProblemType.getPageSize());
        IPage<PcRaProblemType> list = pcRaProblemTypeService.page(page, PcRaProblemTypeQuery.createLambdaQueryWrapper(pcRaProblemType));
        return AjaxResults.success(list);
    }

    @ApiOperation(value = "问题分类级联数据")
    @GetMapping("/cascader")
    public AjaxResults<List<Map<String, Object>>> cascader() {
        List<Map<String, Object>> list = pcRaProblemTypeService.cascader();
        return AjaxResults.success(list);
    }

    /**
     * 导出问题分类列表
     */
    @ApiOperation(value = "导出问题分类")
    @Log(title = "问题分类", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, PcRaProblemType pcRaProblemType) {
        List<PcRaProblemType> list = pcRaProblemTypeService.selectPcRaProblemTypeList(pcRaProblemType);
        ExcelUtil<PcRaProblemType> util = new ExcelUtil<PcRaProblemType>(PcRaProblemType.class);
        util.exportExcel(response, list, "问题分类数据");
    }

    /**
     * 获取问题分类详细信息
     */
    @ApiOperation(value = "获取问题分类详细信息")
    @PostMapping(value = "/{id}")
    public AjaxResults<PcRaProblemType> getInfo(@PathVariable("id") Integer id) {
        return AjaxResults.success(pcRaProblemTypeService.getById(id));
    }

    /**
     * 新增问题分类
     */
    @ApiOperation(value = "新增问题分类")
    @Log(title = "问题分类", businessType = BusinessType.INSERT)
    @PostMapping(value = "/add")
    public AjaxResults<Boolean> add(@RequestBody PcRaProblemType pcRaProblemType) {
        return toAjax(pcRaProblemTypeService.save(pcRaProblemType));
    }

    /**
     * 修改问题分类
     */
    @ApiOperation(value = "修改问题分类")
    @Log(title = "问题分类", businessType = BusinessType.UPDATE)
    @PostMapping(value = "/edit")
    public AjaxResults<Boolean> edit(@RequestBody PcRaProblemTypeVo pcRaProblemTypeVo) {
        if (ObjectUtil.isEmpty(pcRaProblemTypeVo)) {
            throw new InvalidParameterException("参数为空");
        }
        if (ObjectUtil.isEmpty(pcRaProblemTypeVo.getId())) {
            throw new InvalidParameterException("参数id为空");
        }
        PcRaProblemType pcRaProblemType = pcRaProblemTypeService.getById(pcRaProblemTypeVo.getId());
        if (ObjectUtil.isEmpty(pcRaProblemType)) {
            throw new CommonException(StrUtil.format("根据id{}查询不到数据", pcRaProblemTypeVo.getId()));
        }
        //赋值
        BeanUtil.copyProperties(pcRaProblemTypeVo, pcRaProblemType);
        return toAjax(pcRaProblemTypeService.saveOrUpdate(pcRaProblemType));
    }

    /**
     * 删除问题分类
     */
    @ApiOperation(value = "删除问题分类")
    @RequiresPermissions("talroad:type:remove")
    @Log(title = "问题分类", businessType = BusinessType.DELETE)
    @PostMapping("/{ids}")
    public AjaxResults<Boolean> remove(@PathVariable String[] ids) {
        return toAjax(pcRaProblemTypeService.removeByIds(Arrays.asList(ids)));
    }
}
